/****************************************************
 *  C++ Program for AIR HOCKEY GAME	            *
 *  Created by CS 101 Lab Group 161		    *
 *  Team A - Gameplay Coding			    *
 *  Team B - GUI 				    *
 *  1) Akshay Sarode(Group Leader and Team A Leader)*
 *  2) Alok Shah(Team B Leader)			    *
 *  3) Vraj Shah(Team B)			    *
 *  4) Saurabh Bhatt(Team A)			    *
 *  5) Satyabrata Das (Team B)			    *
 *  6) Nida Shaikh (Team A)			    *
 *  						    *
 *  Credits: Gururaj Saileshwar (TA)		    *
 *	     Professor D.B. Phatak(Instructor)	    *
 ****************************************************/

#include <cassert>
#include <iostream>
#include "circle.h"
#include "bitmap.h"
#include "ezwin.h"
#include "rect.h"
#include "time.h"
#include "math.h"
#include <cstring>
#include <cstdio>
using namespace std;


//Creating 4 windows, mainmenu, help, gamestart and gameplay respectively
SimpleWindow MainMenu("Air Hockey", 20.0, 10.0, Position( 4.0, 4.0));
SimpleWindow Gameplay("Air Hockey",20.0, 12.0, Position(3.5, 2.0));
SimpleWindow Helpwin("Air Hockey", 15.0, 15.0, Position(4.0, 4.0));
SimpleWindow GameStart("Air Hockey", 20.0, 10.0, Position(4.0,4.0));

//Creating Bitmaps for photos in Mainmenu Window
BitMap Instructions(Helpwin);
BitMap Photo(MainMenu);
BitMap Newgame(MainMenu);
BitMap Help(MainMenu);
BitMap Exit(MainMenu);
BitMap puck(Gameplay);
BitMap Paddle1(Gameplay);
BitMap Paddle2(Gameplay);
BitMap Mainpic(GameStart);

int prob;					//This probability variable is used to instruct the Artificial intelligence to make errors with a specific 							probability. Otherwise the AI is invincible!!!
float xm,ym;					//xm and ym are the x and y co-ordinates of the point where the mouse was clicked
float up=0.02,vp=0.01,xp=10.0,yp=6.0;		//up and vp are the x and y components of the puck's velocity. xp and yp are its co-ordinates
float u2=0.0, v2=0.001*3,x2=18.5, y2=2.3;	//u2 and v2 are the x and y components of paddle2's velocity. x2 and y2 are its co-ordinates
float u1=0.0, v1=-0.002*5, x1=3.5, y=7.0;	//u1 and v1 are the x and y components of paddle1's velocity. x1 and y1 are its co-ordinates
int score1, score2;				//These are the integer variables to store the scores
float theta,thetam;				//theta is the angle with which the puck is randomly sent from the middle of the field after each goal
						//thetam is the angle made by line joining the point where the mouse was clicked and the left hand top corner of 							paddle1

 
int Mouse(const Position &p){			// Function for movement of Paddle 1 according to mouseclick
	xm=p.GetXDistance();
	ym=p.GetYDistance();
	thetam=atan((y-ym)/(x1-xm));		//We use arctan fuction to get the angle thetam defined above
	v1=-0.02*sin(thetam);			//The puck's speed is then set to 0.02 and the angle is thetam
	u1=-0.02*cos(thetam);			//The puck's speed is then set to 0.02 and the angle is thetam
	if(xm<x1 && u1>0) u1=-u1;		//This code is to correct any errors occuring due to the domain considerations of the trigonometric inverse 							functions
	if(ym<y && v1>0) v1=-v1;		//This code is to correct any errors occuring due to the domain considerations of the trigonometric inverse 							functions
	if(xm>x1 && u1<0) u1=-u1;		//This code is to correct any errors occuring due to the domain considerations of the trigonometric inverse 							functions
	if(ym>y && v1<0) v1=-v1;		//This code is to correct any errors occuring due to the domain considerations of the trigonometric inverse 							functions
	return 1;
}

int Movement(){						//This function is called by the timer periodically and makes the images move and sets their speeds 								appropriately
	puck.Erase();					//First of all, erase the existing images
	Paddle2.Erase();				//First of all, erase the existing images
	Paddle1.Erase();				//First of all, erase the existing images
	Position CurrentPositionp, NewPositionp;
	CurrentPositionp=Position(xp,yp);
	float lp,bp, l2,b2,l1,b1;			//Defining the 6 constants(lenghts and breadths of the 3 images)

	lp=puck.GetWidth();				//Getting the lenghts and breadths of the 3 images.
	bp=puck.GetHeight();				//Getting the lenghts and breadths of the 3 images.
	l2=Paddle2.GetWidth();				//Getting the lenghts and breadths of the 3 images.
	b2=Paddle2.GetHeight();				//Getting the lenghts and breadths of the 3 images.
	l1=Paddle1.GetWidth();				//Getting the lenghts and breadths of the 3 images.
	b1=Paddle1.GetHeight();				//Getting the lenghts and breadths of the 3 images.

	if(0<y2-yp && y2-yp<=bp && x2-lp<xp && xp<x2+l2 && vp>0) vp=-vp;	//collision of puck with paddle 2 from above
	else if(0<yp-y2 && yp-y2<=b2 && x2-lp<xp && xp<x2+l2 && vp<0) vp=-vp;	//collision of puck with paddle 2 from below
	else if(0<x2-xp && x2-xp<=lp && y2-bp<yp && yp<y2+b2 && up>0) up=-up;	//collision of puck with paddle 2 from left
	else if(0<xp-x2 && xp-x2<=l2 && y2-bp<yp && yp<y2+b2 && up<0) up=-up;	//collision of puck with paddle 2 from right
	
	if((yp<=2.0 && xp>1.0 && xp<19.0-lp) || (yp>=10.0-bp && xp>1.0 && xp<19.0-lp)) vp=-vp;		//Collosion of puck with horizontal walls
	else if((xp<=1.0 && yp>2.0 && yp<10.0-bp)||(xp>=19.0-lp && yp>2.0 && yp<10.0-bp)) up=-up;	//Collosion of puck with vertical walls
	else if((xp<=1.0 && yp<=2.0)||(xp>=19.0-lp && yp<=2.0)||(yp>=10.0-bp && xp<=1.0)||(yp>=10.0-bp && xp>=19.0-lp)) {up=-up; vp=-vp;} //Collosion of puck 																		  with corner wall
	if(0<y-yp && y-yp<=bp && x1-lp<xp && xp<x1+l1 && vp>0) vp=-vp;		//collision of puck with with paddle 1 from above
	else if(0<yp-y && yp-y<=b1 && x1-lp<xp && xp<x1+l1 && vp<0) vp=-vp;	//collision of puck with with paddle 1 from below
	else if(0<x1-xp && x1-xp<=lp && y-bp<yp && yp<y+b1 && up>0) up=-up;	//collision of puck with with paddle 1 from left
	else if(0<xp-x1 && xp-x1<=l1 && y-bp<yp && yp<y+b1 && up<0) up=-up;	//collision of puck with with paddle 1 from right
	
	if(0<y-yp && y-yp<=bp && x1-lp<xp && xp<x1+l1 && vp>0 && yp<=1.1 && v1<=0) v1=-v1;	//collision of paddle 1 with puck when paddle 1 would try to 													push the puck inside the wall(this code is written to prevent the 													puck from going inside the wall)
	if(0<yp-y && yp-y<=b1 && x1-lp<xp && xp<x1+l1 && vp<0 && yp>=9.9-bp && v1>=0) v1=-v1;  //collision of paddle 1 with puck when paddle 1 would try to 													push the puck inside the wall(this code is written to prevent the 													puck from going inside the wall)

	if(0<y2-yp && y2-yp<=bp && x2-lp<xp && xp<x2+l2 && vp>0 && yp<=1.1 && v2<=0) v2=-v2;	//collision of paddle 2 with puck when paddle 2 would try to 													push the puck inside the wall(this code is written to prevent the 													puck from going inside the wall)
	if(0<yp-y2 && yp-y2<=b2 && x2-lp<xp && xp<x2+l2 && vp<0 && yp>=9.9-bp && v2>=0) v2=-v2;//collision of paddle 2 with puck when paddle 2 would try to 													push the puck inside the wall(this code is written to prevent the 													puck from going inside the wall)

	NewPositionp=CurrentPositionp + Position(up,vp);
	xp=xp+up; yp=yp+vp;
	puck.SetPosition(NewPositionp);
	puck.Draw();
	
	//paddle 2 Automatic movement
	Position NewPosition2;
	srand(time(0));							//The time() function with 0 as parameter is used to set seed for the rand() function
	prob=rand();							//The integer variable prob is assingned a pseudorandom value
	if(prob%2!=0) {if(yp<=2.0){y2=2;}				//Setting the probability of AI error to be (1/2)
	if(yp>2.0 && yp<(10.0-b2)){y2=yp;}				//Following the puck
	if(yp>(10.0-b2) && yp<=10.0){y2=10-b2;}				//Following the puck
	
	if((x2-xp)<2){x2=x2-0.007;}
	else{x2=x2+0.005;}
	
	if(x2<=16.0){x2=16.0;}
	else if(x2>16.0 && x2<(19-l2)){x2=x2;}
	else if(x2>=19-l2){x2=19-l2;}
	}

	NewPosition2=Position(x2,y2);
	Paddle2.SetPosition(NewPosition2);
	Paddle2.Draw();
	
	Position CurrentPosition1, NewPosition1;
	CurrentPosition1=Position(x1,y);
	if((y<=2.0 && x1>1.0 && x1<19.0-lp)||(y>=10.0-b1 && x1>1.0 && x1<19.0-l1)) v1=-v1;	// Collision of Paddle 1 with walls
	else if((x1<=1.0 && y>2.0 && y<10.0-b1)||(x1>=19.0-l1 && y>2.0 && y<10.0-b1)) u1=-u1;	// Collision of Paddle 1 with walls
	else if((x1<=1.0 && y<=2.0)||(x1>=19.0-l1 && y<=2.0)||(y>=10.0-b1 && x1<=1.0)||(y>=10.0-b1 && x1>=19.0-l1)) {u1=-u1; v1=-v1;}	//Collision of Paddle 1 																	with walls
	if(x1>=4.0) u1=-u1;									//Restricting paddle 1 between x=1.0 and x=4.0
	NewPosition1=CurrentPosition1 + Position(u1,v1);
	x1=x1+u1; y=y+v1;
	Paddle1.SetPosition(NewPosition1);
	Paddle1.Draw();
	
	//Program for Scores
	if(xp<=1.0) {									//Goal is scored when puck's x-xoordinate becomes less equal 1.0
		Paddle1.Erase();
		Paddle2.Erase();
		puck.Erase();
		puck.Draw();
		score2+=1; 
		Gameplay.Message("Computer scored a goal."); 
		srand(time(0)); do{theta=rand();} while(cos(theta)==0 || sin(theta)==0 || cos(theta)<=0.4); up=0.024*cos(theta);
		vp=0.024*sin(theta)*pow((-1),rand());	// After each goal, the puck will be released with a speed 0.024 and at an angle between 0 and arccos(0.4)
		xp=10.0;
		yp=6.0;}
	if(xp>=19.0-lp) {								//Goal is scored when puck's x-xoordinate becomes greater equal 19.0-lp
		Paddle1.Erase();
		Paddle2.Erase();
		puck.Erase();
		puck.Draw();
		score1+=1; 
		Gameplay.Message("You scored a goal!"); 
		srand(time(0)); do{theta=rand();} while(cos(theta)==0 || sin(theta)==0 || cos(theta)<=0.4); up=0.024*cos(theta)*pow((-1),rand());
		vp=0.024*sin(theta)*pow((-1),rand());  // After each goal, the puck will be released with a speed 0.024 and at an angle between 0 and arccos(0.4)
		xp=10.0;
		yp=6.0;}
	cout<<"Player's score : "<<score1<<endl;
	cout<<"Computer's score : "<<score2<<endl;
	
	//End of the game
	if(score1==7)
	{
	Gameplay.Message("You won the Game!!!");
	Gameplay.Close();
	}
	else if(score2==7)
	{
		Gameplay.Message("Computer won the Game.");
		Gameplay.Close();						//Closing of gameplay window
	}	
		

	return 1;
}

int MouseClick2(const Position &MousePosition)
{

	if(Newgame.IsInside(MousePosition)){					//If the "NEW GAME" button is clicked, this block of code is executed
	
	//Getting Player Details inside Terminal Window
		char Player[10];
		cout<<"Player's name should not be more than 10 characters.\n\n";
		cout<<"Enter Player's Name: ";
		gets(Player);
		cout<<"\n \n Player name is "<<Player;
		
		MainMenu.Close();	
		Gameplay.Open();
		assert(Gameplay.GetStatus() == WindowOpen);

		// Get Center of Window
		Position Center = Gameplay.GetCenter();
		Gameplay.Message("Are you ready!!!!");
		Gameplay.Message("Please note that while playing the computer controlled paddle stops moving for a while, and again starts moving.");
		Gameplay.Message("This stopping of the computer paddle is not a malfunction, but it's programmed to do so. Otherwise it will be unbeatable!");
		Gameplay.Message("Click OK to start the game!!! The match will be of 7 goals.");
	
		//create rectangle for the Gameplay
		Gameplay.RenderRectangle(Position(0.0,0.0), Position(20.0,12.0), Cyan, true);
		Gameplay.RenderRectangle(Position(0.9,1.9), Position(19.1,10.1), Black, true);
		Gameplay.RenderRectangle(Position(1.0-0.05,2.0-0.05), Position(19.0+0.05,10.0+0.05), White, true);
		
		//Display Text
		Gameplay.RenderText(Position(1.0,0), Position(4.0,1), "Player :", Red);
		Gameplay.RenderText(Position(4.0,0), Position(6.0,1), Player, Red);
		Gameplay.RenderText(Position(16,0.8), Position(18.0,1.0), "COMPUTER", Red);  	
		
		puck.Load("puck.xpm");
		assert(puck.GetStatus()==BitMapOkay);
		
		Paddle2.Load("paddle2.xpm");
		assert(Paddle2.GetStatus()==BitMapOkay);
	
		Paddle2.SetPosition(Position(x2,y2));
		Paddle2.Draw();
	
		Paddle1.Load("paddle1.xpm");
		assert(Paddle1.GetStatus()==BitMapOkay);

		Paddle1.SetPosition(Position(x1,y));
		Paddle1.Draw();
	
		puck.SetPosition(Position(xp,yp));
		puck.Draw();
		Gameplay.StartTimer(2);					//The timer is set to go off at every 2 milliseconds
		Gameplay.SetTimerCallback(Movement);			//The "Movement" function is called by the timer
		Gameplay.SetMouseClickCallback(Mouse);			//The MouseClickCallback is set to the function "Mouse" which is the function which controls 										the manual movement of Paddle1 according to mouseclick
	
	}
	
	if(Help.IsInside(MousePosition))			//If the "HELP" button is clicked, this block of code is executed
	{
		Helpwin.Open();
		assert(Helpwin.GetStatus() == WindowOpen);
		Position Center = Helpwin.GetCenter();
		Instructions.Load("instructions.xpm");
		assert(Instructions.GetStatus() == BitMapOkay);
		Position Pos1 = Center + Position(-0.5*Instructions.GetWidth(), -0.5*Instructions.GetHeight());
		Instructions.SetPosition(Pos1);
		Instructions.Draw();
	}
	
	if(Exit.IsInside(MousePosition))			//If the "QUIT" button is clicked, this block of code is executed
	{
		Gameplay.Close();
		MainMenu.Close();
		Helpwin.Close();
	}
return 1;
}

//writing function for Mouse click event
int MouseClick(const Position &MousePosition)			//This function closes the "Click to continue" window and opens the MainMenu window
{
	if(Mainpic.IsInside(MousePosition));
	{
		GameStart.Close();				//Close the "Click to continue" window.
		//coding for Main menu Window
		MainMenu.Open();				//Open the MainMenu window		
		assert( MainMenu.GetStatus() == WindowOpen);
		Position Center = MainMenu.GetCenter();
	
		//Loading Background Photo for Main Menu Window
		Photo.Load("photo.xpm");
		assert(Photo.GetStatus() == BitMapOkay);
		Position PicPos = Center + Position(-.5*Photo.GetWidth(), -.5*Photo.GetHeight());
		Photo.SetPosition(PicPos);
		Photo.Draw();
		
		//New Game Button image
		Newgame.Load("newgame.xpm");
		assert(Newgame.GetStatus() == BitMapOkay);
		Position P1 = Center + Position(-2.5, -3.0);
		Newgame.SetPosition(P1);
		Newgame.Draw();
		
		//Help Button Image
		Help.Load("help.xpm"); 
		assert(Help.GetStatus() == BitMapOkay);
		Position P2 = Center + Position(-2.5, 0.0);
		Help.SetPosition(P2);
		Help.Draw();
		
		//Quit Button image
		Exit.Load("quit.xpm");
		assert(Exit.GetStatus() == BitMapOkay);
		Position P3 = Center + Position(-2.5, 3.0);
		Exit.SetPosition(P3);
		Exit.Draw();
		
		MainMenu.Message("Please make sure that this game is executed through the terminal. If not, please run it through the terminal. Thank you.");
		MainMenu.Message("Note that on clicking NEW GAME, you have to type the player's name in the TERMINAL. Thank you.");
		//Initiating Callback for clicking event
		MainMenu.SetMouseClickCallback(MouseClick2);		//Now setting the MouseClickCallback to MouseClick2
	}

	
	return 1;
}	

int ApiMain()									//The ApiMain function which is called by the OS.
{
	GameStart.Open();
	assert(GameStart.GetStatus() == WindowOpen);
	Position Center = GameStart.GetCenter();
	Mainpic.Load("gamestart.xpm");
	assert(Mainpic.GetStatus() == BitMapOkay);
	Position Pos2 = Center + Position(-0.5*Mainpic.GetWidth(), -0.5*Mainpic.GetHeight());
	Mainpic.SetPosition(Pos2);
	Mainpic.Draw();		
	GameStart.SetMouseClickCallback(MouseClick);				//First of all, the MouseClickCallback is set to the function MouseClick
	return 0;
}
